import { each } from 'underscore';
import Backbone from 'backbone';

module.exports = Backbone.Model.extend({
  /** @inheritdoc */
  build(model) {
    const json = model.toJSON();
    this.beforeEach(json);
    console.log('PASO', json);
    each(
      json,
      function(v, attr) {
        const obj = json[attr];
        if (obj instanceof Backbone.Model) {
          json[attr] = this.build(obj);
        } else if (obj instanceof Backbone.Collection) {
          const coll = obj;
          json[attr] = [];
          if (coll.length) {
            coll.each(function(el, index) {
              json[attr][index] = this.build(el);
            }, this);
          }
        }
      },
      this
    );

    return json;
  },

  /**
   * Execute on each object
   * @param {Object} obj
   */
  beforeEach(obj) {
    delete obj.status;
  }
});
