import { isArray } from 'underscore';

module.exports = {
  run(ed, sender, opts = {}) {
    if (ed.getModel().isEditing() || ed.Canvas.isInputFocused()) return;
    let components = opts.component || ed.getSelectedAll();
    components = isArray(components) ? [...components] : [components];
    ed.select(null);
    components.forEach(component => {
      if (!component || !component.get('removable')) {
        console.warn('The element is not removable', component);
        return;
      }
      if (component) {
        const coll = component.collection;
        component.trigger('component:destroy');
        if (coll && coll.remove) {
          coll.remove(component);
        }
      }
    });
    return components;
  }
};
