module.exports = {
  run(editor, sender, opts) {
    const el = (opts && opts.el) || '';
    const canvas = editor.Canvas;
    let dragger = this.dragger;
    const options = opts.options || {};
    const canvasView = canvas.getCanvasView();
    options.prefix = editor.getConfig().stylePrefix;
    options.mousePosFetcher = canvas.getMouseRelativePos;
    options.posFetcher = canvasView.getElementPos.bind(canvasView);
    if (!dragger) {
      dragger = editor.Utils.Dragger.init(options);
      this.dragger = dragger;
    }
    dragger.setOptions(options);
    dragger.focus(el);
    if (options.event) {
      dragger.start(options.event);
    }
    return dragger;
  },
  stop() {
    if (this.canvasResizer) this.canvasResizer.blur();
  }
};
