import _ from 'underscore';

const CreateComponent = require('./CreateComponent');

module.exports = _.extend({}, CreateComponent, {
  init(...args) {
    CreateComponent.init.apply(this, args);
    _.bindAll(this, 'insertComponent');
    this.allowDraw = 0;
  },
  run(em, sender, options) {
    this.em = em;
    this.sender = sender;
    this.opt = options || {};
    this.$wr = this.$wrapper;
    this.enable();
  },
  enable(...args) {
    CreateComponent.enable.apply(this, args);
    this.$wr.on('click', this.insertComponent);
  },
  insertComponent() {
    this.$wr.off('click', this.insertComponent);
    this.stopSelectPosition();
    const object = this.buildContent();
    this.beforeInsert(object);
    const index = this.sorter.lastPos.index;
    // By default, collections do not trigger add event, so silent is used
    const model = this.create(this.sorter.target, object, index, null, {
      silent: false
    });
    if (this.opt.terminateAfterInsert && this.sender) {
      this.sender.set('active', false);
    } else {
      this.enable();
    }
    if (!model) {
      return;
    }
    this.afterInsert(model, this);
  },
  beforeInsert() {},
  afterInsert() {},
  buildContent() {
    return this.opt.content || {};
  }
});
