import Backbone from 'backbone';

const $ = Backbone.$;

module.exports = {
  run(em, sender) {
    this.sender = sender;
    if (!this.$cn) {
      const config = em.getConfig();
      const panels = em.Panels;
      this.$cn = $('<div></div>');
      this.$cn2 = $('<div></div>');
      this.$cn.append(this.$cn2);
      const dvm = em.DeviceManager;
      if (dvm && config.showDevices) {
        const devicePanel = panels.addPanel({ id: 'devices-c' });
        devicePanel
          .set('appendContent', dvm.render())
          .trigger('change:appendContent');
      }
      const clm = em.SelectorManager;
      if (clm) {
        this.$cn2.append(clm.render([]));
      }
      this.$cn2.append(em.StyleManager.render());
      const smConfig = em.StyleManager.getConfig();
      const pfx = smConfig.stylePrefix;
      this.$header = $(
        `<div class="${pfx}header">${smConfig.textNoElement}</div>`
      );
      this.$cn.append(this.$header);
      if (!panels.getPanel('views-container')) {
        this.panel = panels.addPanel({ id: 'views-container' });
      } else {
        this.panel = panels.getPanel('views-container');
      }
      this.panel.set('appendContent', this.$cn).trigger('change:appendContent');
      this.target = em.editor;
      this.listenTo(this.target, 'component:toggled', this.toggleSm);
    }
    this.toggleSm();
  },
  toggleSm() {
    const { target, sender } = this;
    if (sender && sender.get && !sender.get('active')) {
      return;
    }
    if (target.getSelectedAll().length === 1) {
      this.$cn2.show();
      this.$header.hide();
    } else {
      this.$cn2.hide();
      this.$header.show();
    }
  },
  stop() {
    if (this.$cn2) this.$cn2.hide();
    if (this.$header) this.$header.hide();
  }
};
