module.exports = {
  run(editor, sender, opts) {
    const opt = opts || {};
    const el = opt.el || '';
    const canvas = editor.Canvas;
    let canvasResizer = this.canvasResizer;
    const options = opt.options || {};
    const canvasView = canvas.getCanvasView();
    options.ratioDefault = 1;
    options.appendTo = canvas.getResizerEl();
    options.prefix = editor.getConfig().stylePrefix;
    options.posFetcher = canvasView.getElementPos.bind(canvasView);
    options.mousePosFetcher = canvas.getMouseRelativePos;
    if (!canvasResizer || opt.forceNew) {
      this.canvasResizer = editor.Utils.Resizer.init(options);
      canvasResizer = this.canvasResizer;
    }
    canvasResizer.setOptions(options);
    canvasResizer.blur();
    canvasResizer.focus(el);
    return canvasResizer;
  },
  stop() {
    const resizer = this.canvasResizer;
    if (resizer && resizer.blur) {
      resizer.blur();
    }
  }
};
