module.exports = () => {
  let c = {};
  const defaults = require('./config/config');
  const Devices = require('./model/Devices');
  const DevicesView = require('./view/DevicesView');
  let devices;
  let view;

  return {
    name: 'DeviceManager',
    init(config) {
      c = config || {};
      for (const name in defaults) {
        if (!(name in c)) c[name] = defaults[name];
      }
      devices = new Devices(c.devices);
      view = new DevicesView({
        collection: devices,
        config: c
      });
      return this;
    },
    add(name, width, opts) {
      const obj = opts || {};
      obj.name = name;
      obj.width = width;
      return devices.add(obj);
    },
    get(name) {
      return devices.get(name);
    },
    getAll() {
      return devices;
    },
    render() {
      return view.render().el;
    }
  };
};
