const ComponentView = require('./ComponentImageView');

module.exports = ComponentView.extend({
  tagName: 'script',
  events: {},
  render() {
    const model = this.model;
    const src = model.get('src');
    const em = this.em;
    const scriptCount = em && em.get('scriptCount') ? em.get('scriptCount') : 0;
    let content = '';
    if (src) {
      const onload = model.get('onload');
      const svar = `script${scriptCount}`;
      const svarNext = `script${scriptCount + 1}`;
      content =
        `var ${svar} = document.createElement('script');\n${svar}.onload = function(){\n${
          onload ? `${onload}();\n` : ''
        }typeof ${svarNext}Start == 'function' && ${svarNext}Start();\n` +
        `};\n${svar}.src = '${src}';\n` +
        `function ${svar}Start() { document.body.appendChild(${svar}); };\n${
          !scriptCount ? `${svar}Start();` : ''
        }`;
      if (em) {
        em.set('scriptCount', scriptCount + 1);
      }
    } else {
      content = model.get('content');
    }

    this.el.innerHTML = content;
    return this;
  }
});
