const Backbone = require('backbone');

module.exports = Backbone.View.extend({
  itemView: '',
  itemsView: '',
  itemType: 'type',
  initialize(opts, config) {
    this.config = config || {};
  },
  addTo(model) {
    this.add(model);
  },
  add(model, fragment) {
    const frag = fragment || null;
    let itemView = this.itemView;
    const typeField = model.get(this.itemType);
    if (this.itemsView && this.itemsView[typeField]) {
      itemView = this.itemsView[typeField];
    }
    const view = new itemView(
      {
        model,
        config: this.config
      },
      this.config
    );
    const rendered = view.render().el;
    if (frag) {
      frag.appendChild(rendered);
    } else {
      this.$el.append(rendered);
    }
  },
  render() {
    const frag = document.createDocumentFragment();
    this.$el.empty();
    if (this.collection.length)
      this.collection.each(function(model) {
        this.add(model, frag);
      }, this);
    this.$el.append(frag);
    return this;
  }
});
