const Backbone = require('backbone');
const Button = require('./Button');

module.exports = Backbone.Collection.extend({
  model: Button,
  deactivateAllExceptOne(except, r) {
    this.forEach(model => {
      if (model !== except) {
        model.set('active', false);
        if (r && model.get('buttons').length)
          model.get('buttons').deactivateAllExceptOne(except, r);
      }
    });
  },
  deactivateAll(ctx) {
    const context = ctx || '';
    this.forEach(model => {
      if (model.get('context') == context) {
        model.set('active', false);
        if (model.get('buttons').length)
          model.get('buttons').deactivateAll(context);
      }
    });
  },
  disableAllButtons(ctx) {
    const context = ctx || '';
    this.forEach(model => {
      if (model.get('context') == context) {
        model.set('disable', true);
        if (model.get('buttons').length)
          model.get('buttons').disableAllButtons(context);
      }
    });
  },
  disableAllButtonsExceptOne(except, r) {
    this.forEach(model => {
      if (model !== except) {
        model.set('disable', true);
        if (r && model.get('buttons').length)
          model.get('buttons').disableAllButtonsExceptOne(except, r);
      }
    });
  }
});
