module.exports = () => {
  let conf = {};
  const defaults = require('./config/config');
  const parserCss = require('./model/ParserCss');
  const parserHtml = require('./model/ParserHtml');
  let pHtml;
  let pCss;

  return {
    compTypes: '',
    parserCss: null,
    parserHtml: null,
    name: 'Parser',
    getConfig() {
      return conf;
    },
    init(config = {}) {
      conf = { ...defaults, ...config };
      conf.Parser = this;
      pHtml = new parserHtml(conf);
      pCss = new parserCss(conf);
      this.em = conf.em;
      return this;
    },
    parseHtml(str) {
      const { em, compTypes } = this;
      pHtml.compTypes = em ? em.get('DomComponents').getTypes() : compTypes;
      return pHtml.parse(str, pCss);
    },
    parseCss(str) {
      return pCss.parse(str);
    }
  };
};
