module.exports = config => {
  const c = config || {};
  const defaults = require('./config/config');

  // Set default options
  for (const name in defaults) {
    if (!(name in c)) c[name] = defaults[name];
  }

  const plugins = {};

  return {
    add(id, plugin) {
      if (plugins[id]) {
        return plugins[id];
      }

      plugins[id] = plugin;
      return plugin;
    },
    get(id) {
      return plugins[id];
    },
    getAll() {
      return plugins;
    }
  };
};
