import Backbone from 'backbone';

module.exports = Backbone.Model.extend({
  defaults: {
    index: '',
    value: '',
    values: {},
    active: false,
    preview: false,
    properties: []
  },

  initialize() {
    const Properties = require('./Properties');
    const properties = this.get('properties');
    const value = this.get('value');
    this.set(
      'properties',
      properties instanceof Properties ? properties : new Properties(properties)
    );
    this.get('properties').forEach(item => {
      const { collection } = this;
      item.parent = collection && collection.property;
    });
    if (!value) {
      let val = '';
      const values = this.get('values');
      for (const prop in values) {
        val += ` ${values[prop]}`;
      }
      this.set('value', val.trim());
    }
  },
  getPropertyAt(index) {
    return this.get('properties').at(index);
  },
  getPropertyValue(property) {
    let result = '';
    this.get('properties').each(prop => {
      if (prop.get('property') == property) {
        result = prop.getFullValue();
      }
    });
    return result;
  },
  getFullValue() {
    const result = [];
    this.get('properties').each(prop => result.push(prop.getFullValue()));
    return result.join(' ');
  }
});
