const Property = require('./PropertyComposite');
const Layers = require('./Layers');

module.exports = Property.extend({
  defaults: {
    ...Property.prototype.defaults,
    layers: [],
    layerSeparator: ', ',
    preview: 0
  },
  initialize(props = {}, opts = {}) {
    Property.callParentInit(Property, this, props, opts);
    const layers = this.get('layers');
    const layersColl = new Layers(layers);
    layersColl.property = this;
    layersColl.properties = this.get('properties');
    this.set('layers', layersColl);
    Property.callInit(this, props, opts);
  },
  getLayers() {
    return this.get('layers');
  },
  getCurrentLayer() {
    return this.getLayers().filter(layer => layer.get('active'))[0];
  },
  getFullValue() {
    return this.get('detached') ? '' : this.get('layers').getFullValue();
  },
  getLayersFromTarget() {}
});
