import { defaults, isElement } from 'underscore';

const defaultOpts = require('./config/config');
const TraitsView = require('./view/TraitsView');

module.exports = () => {
  let c = {};
  let TraitsViewer;

  return {
    TraitsView,
    name: 'TraitManager',
    getConfig() {
      return c;
    },
    init(config = {}) {
      c = config;
      defaults(c, defaultOpts);
      const ppfx = c.pStylePrefix;
      ppfx && (c.stylePrefix = `${ppfx}${c.stylePrefix}`);
      TraitsViewer = new TraitsView({
        collection: [],
        editor: c.em,
        config: c
      });
      return this;
    },
    postRender() {
      const elTo = this.getConfig().appendTo;
      if (elTo) {
        const el = isElement(elTo) ? elTo : document.querySelector(elTo);
        el.appendChild(this.render());
      }
    },
    getTraitsViewer() {
      return TraitsViewer;
    },
    addType(name, trait) {
      const itemView = TraitsViewer.itemView;
      TraitsViewer.itemsView[name] = itemView.extend(trait);
    },
    getType(name) {
      return TraitsViewer.itemsView[name];
    },
    render() {
      return TraitsViewer.render().el;
    }
  };
};
