const TraitView = require('./TraitView');
const InputNumber = require('domain_abstract/ui/InputNumber');

module.exports = TraitView.extend({
  getValueForTarget() {
    const model = this.model;
    const value = model.get('value');
    const unit = model.get('unit');
    return value ? value + unit : '';
  },
  getInputEl() {
    if (!this.$input) {
      const value = this.getModelValue();
      const inputNumber = new InputNumber({
        contClass: `${this.ppfx}field-int`,
        model: this.model,
        ppfx: this.ppfx
      });
      this.input = inputNumber.render();
      this.$input = this.input.inputEl;
      this.$unit = this.input.unitEl;
      this.model.set('value', value);
      this.$input.val(value);
    }
    return this.$input.get(0);
  },
  renderField() {
    if (!this.$input) {
      this.$el.append(this.tmpl);
      this.getInputEl();
      this.$el.find(`.${this.inputhClass}`).prepend(this.input.el);
    }
  }
});
